Index: trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorGraphView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorGraphView.Designer.cs	(revision 3514)
+++ trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorGraphView.Designer.cs	(revision 3523)
@@ -35,5 +35,5 @@
       this.zoomOutButton = new System.Windows.Forms.Button();
       this.zoomInButton = new System.Windows.Forms.Button();
-      this.zoomAreaButton = new System.Windows.Forms.Button();
+      this.zoomToFitButton = new System.Windows.Forms.Button();
       this.relayoutButton = new System.Windows.Forms.Button();
       this.connectButton = new System.Windows.Forms.Button();
@@ -107,5 +107,5 @@
       this.splitContainer.Panel1.Controls.Add(this.zoomOutButton);
       this.splitContainer.Panel1.Controls.Add(this.zoomInButton);
-      this.splitContainer.Panel1.Controls.Add(this.zoomAreaButton);
+      this.splitContainer.Panel1.Controls.Add(this.zoomToFitButton);
       this.splitContainer.Panel1.Controls.Add(this.relayoutButton);
       this.splitContainer.Panel1.Controls.Add(this.connectButton);
@@ -156,12 +156,12 @@
       // zoomAreaButton
       // 
-      this.zoomAreaButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.ActualSize;
-      this.zoomAreaButton.Location = new System.Drawing.Point(153, 3);
-      this.zoomAreaButton.Name = "zoomAreaButton";
-      this.zoomAreaButton.Size = new System.Drawing.Size(24, 24);
-      this.zoomAreaButton.TabIndex = 5;
-      this.buttonToolTip.SetToolTip(this.zoomAreaButton, "Zoom Area Tool");
-      this.zoomAreaButton.UseVisualStyleBackColor = true;
-      this.zoomAreaButton.Click += new System.EventHandler(this.zoomAreaButton_Click);
+      this.zoomToFitButton.Image = HeuristicLab.Common.Resources.VS2008ImageLibrary.ActualSize;
+      this.zoomToFitButton.Location = new System.Drawing.Point(153, 3);
+      this.zoomToFitButton.Name = "zoomAreaButton";
+      this.zoomToFitButton.Size = new System.Drawing.Size(24, 24);
+      this.zoomToFitButton.TabIndex = 5;
+      this.buttonToolTip.SetToolTip(this.zoomToFitButton, "Zoom to Fit");
+      this.zoomToFitButton.UseVisualStyleBackColor = true;
+      this.zoomToFitButton.Click += new System.EventHandler(this.zoomAreaButton_Click);
       // 
       // relayoutButton
@@ -267,5 +267,5 @@
     private System.Windows.Forms.Button zoomOutButton;
     private System.Windows.Forms.Button zoomInButton;
-    private System.Windows.Forms.Button zoomAreaButton;
+    private System.Windows.Forms.Button zoomToFitButton;
     private System.Windows.Forms.Button relayoutButton;
     private System.Windows.Forms.Button connectButton;
Index: trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorGraphView.cs
===================================================================
--- trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorGraphView.cs	(revision 3514)
+++ trunk/sources/HeuristicLab.Operators.Views.GraphVisualization/3.3/OperatorGraphVisualization/OperatorGraphView.cs	(revision 3523)
@@ -91,5 +91,5 @@
         panButton.Enabled = false;
         relayoutButton.Enabled = false;
-        zoomAreaButton.Enabled = false;
+        zoomToFitButton.Enabled = false;
         zoomInButton.Enabled = false;
         zoomOutButton.Enabled = false;
@@ -101,5 +101,5 @@
         panButton.Enabled = true;
         relayoutButton.Enabled = true;
-        zoomAreaButton.Enabled = true;
+        zoomToFitButton.Enabled = true;
         zoomInButton.Enabled = true;
         zoomOutButton.Enabled = true;
@@ -281,5 +281,5 @@
           break;
         case ControllerBase.ZoomAreaToolName:
-          button = this.zoomAreaButton;
+          button = this.zoomToFitButton;
           break;
       }