Index: trunk/sources/HeuristicLab.Common/3.3/Content/StorableContent.cs
===================================================================
--- trunk/sources/HeuristicLab.Common/3.3/Content/StorableContent.cs	(revision 3549)
+++ trunk/sources/HeuristicLab.Common/3.3/Content/StorableContent.cs	(revision 3550)
@@ -28,5 +28,6 @@
       get { return filename; }
       set {
-        if (!filename.Equals(value)) {
+        if (value == null) throw new ArgumentNullException();
+        if ((filename == null) || !filename.Equals(value)) {
           filename = value;
           OnFilenameChanged();
Index: trunk/sources/HeuristicLab.Core/3.3/Collections/ItemArray.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/Collections/ItemArray.cs	(revision 3549)
+++ trunk/sources/HeuristicLab.Core/3.3/Collections/ItemArray.cs	(revision 3550)
@@ -40,5 +40,6 @@
       get { return filename; }
       set {
-        if (!filename.Equals(value)) {
+        if (value == null) throw new ArgumentNullException();
+        if ((filename == null) || !filename.Equals(value)) {
           filename = value;
           OnFilenameChanged();
Index: trunk/sources/HeuristicLab.Core/3.3/Collections/ItemCollection.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/Collections/ItemCollection.cs	(revision 3549)
+++ trunk/sources/HeuristicLab.Core/3.3/Collections/ItemCollection.cs	(revision 3550)
@@ -37,5 +37,6 @@
       get { return filename; }
       set {
-        if (!filename.Equals(value)) {
+        if (value == null) throw new ArgumentNullException();
+        if ((filename == null) || !filename.Equals(value)) {
           filename = value;
           OnFilenameChanged();
Index: trunk/sources/HeuristicLab.Core/3.3/Collections/ItemDictionary.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/Collections/ItemDictionary.cs	(revision 3549)
+++ trunk/sources/HeuristicLab.Core/3.3/Collections/ItemDictionary.cs	(revision 3550)
@@ -37,5 +37,6 @@
       get { return filename; }
       set {
-        if (!filename.Equals(value)) {
+        if (value == null) throw new ArgumentNullException();
+        if ((filename == null) || !filename.Equals(value)) {
           filename = value;
           OnFilenameChanged();
Index: trunk/sources/HeuristicLab.Core/3.3/Collections/ItemList.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/Collections/ItemList.cs	(revision 3549)
+++ trunk/sources/HeuristicLab.Core/3.3/Collections/ItemList.cs	(revision 3550)
@@ -40,5 +40,6 @@
       get { return filename; }
       set {
-        if (!filename.Equals(value)) {
+        if (value == null) throw new ArgumentNullException();
+        if ((filename == null) || !filename.Equals(value)) {
           filename = value;
           OnFilenameChanged();
Index: trunk/sources/HeuristicLab.Core/3.3/Collections/ItemSet.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/Collections/ItemSet.cs	(revision 3549)
+++ trunk/sources/HeuristicLab.Core/3.3/Collections/ItemSet.cs	(revision 3550)
@@ -40,5 +40,6 @@
       get { return filename; }
       set {
-        if (!filename.Equals(value)) {
+        if (value == null) throw new ArgumentNullException();
+        if ((filename == null) || !filename.Equals(value)) {
           filename = value;
           OnFilenameChanged();
Index: trunk/sources/HeuristicLab.Core/3.3/Collections/KeyedItemCollection.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/Collections/KeyedItemCollection.cs	(revision 3549)
+++ trunk/sources/HeuristicLab.Core/3.3/Collections/KeyedItemCollection.cs	(revision 3550)
@@ -36,5 +36,6 @@
       get { return filename; }
       set {
-        if (!filename.Equals(value)) {
+        if (value == null) throw new ArgumentNullException();
+        if ((filename == null) || !filename.Equals(value)) {
           filename = value;
           OnFilenameChanged();
Index: trunk/sources/HeuristicLab.Core/3.3/Collections/ReadOnlyItemArray.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/Collections/ReadOnlyItemArray.cs	(revision 3549)
+++ trunk/sources/HeuristicLab.Core/3.3/Collections/ReadOnlyItemArray.cs	(revision 3550)
@@ -37,5 +37,6 @@
       get { return filename; }
       set {
-        if (!filename.Equals(value)) {
+        if (value == null) throw new ArgumentNullException();
+        if ((filename == null) || !filename.Equals(value)) {
           filename = value;
           OnFilenameChanged();
Index: trunk/sources/HeuristicLab.Core/3.3/Collections/ReadOnlyItemCollection.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/Collections/ReadOnlyItemCollection.cs	(revision 3549)
+++ trunk/sources/HeuristicLab.Core/3.3/Collections/ReadOnlyItemCollection.cs	(revision 3550)
@@ -37,5 +37,6 @@
       get { return filename; }
       set {
-        if (!filename.Equals(value)) {
+        if (value == null) throw new ArgumentNullException();
+        if ((filename == null) || !filename.Equals(value)) {
           filename = value;
           OnFilenameChanged();
Index: trunk/sources/HeuristicLab.Core/3.3/Collections/ReadOnlyItemDictionary.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/Collections/ReadOnlyItemDictionary.cs	(revision 3549)
+++ trunk/sources/HeuristicLab.Core/3.3/Collections/ReadOnlyItemDictionary.cs	(revision 3550)
@@ -37,5 +37,6 @@
       get { return filename; }
       set {
-        if (!filename.Equals(value)) {
+        if (value == null) throw new ArgumentNullException();
+        if ((filename == null) || !filename.Equals(value)) {
           filename = value;
           OnFilenameChanged();
Index: trunk/sources/HeuristicLab.Core/3.3/Collections/ReadOnlyItemList.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/Collections/ReadOnlyItemList.cs	(revision 3549)
+++ trunk/sources/HeuristicLab.Core/3.3/Collections/ReadOnlyItemList.cs	(revision 3550)
@@ -37,5 +37,6 @@
       get { return filename; }
       set {
-        if (!filename.Equals(value)) {
+        if (value == null) throw new ArgumentNullException();
+        if ((filename == null) || !filename.Equals(value)) {
           filename = value;
           OnFilenameChanged();
Index: trunk/sources/HeuristicLab.Core/3.3/Collections/ReadOnlyItemSet.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/Collections/ReadOnlyItemSet.cs	(revision 3549)
+++ trunk/sources/HeuristicLab.Core/3.3/Collections/ReadOnlyItemSet.cs	(revision 3550)
@@ -37,5 +37,6 @@
       get { return filename; }
       set {
-        if (!filename.Equals(value)) {
+        if (value == null) throw new ArgumentNullException();
+        if ((filename == null) || !filename.Equals(value)) {
           filename = value;
           OnFilenameChanged();
Index: trunk/sources/HeuristicLab.Core/3.3/Collections/ReadOnlyKeyedItemCollection.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/Collections/ReadOnlyKeyedItemCollection.cs	(revision 3549)
+++ trunk/sources/HeuristicLab.Core/3.3/Collections/ReadOnlyKeyedItemCollection.cs	(revision 3550)
@@ -37,5 +37,6 @@
       get { return filename; }
       set {
-        if (!filename.Equals(value)) {
+        if (value == null) throw new ArgumentNullException();
+        if ((filename == null) || !filename.Equals(value)) {
           filename = value;
           OnFilenameChanged();
Index: trunk/sources/HeuristicLab.Core/3.3/Item.cs
===================================================================
--- trunk/sources/HeuristicLab.Core/3.3/Item.cs	(revision 3549)
+++ trunk/sources/HeuristicLab.Core/3.3/Item.cs	(revision 3550)
@@ -36,5 +36,6 @@
       get { return filename; }
       set {
-        if (!filename.Equals(value)) {
+        if (value == null) throw new ArgumentNullException();
+        if ((filename == null) || !filename.Equals(value)) {
           filename = value;
           OnFilenameChanged();