Index: trunk/sources/HeuristicLab.Core.Views/3.3/Clipboard.cs
===================================================================
--- trunk/sources/HeuristicLab.Core.Views/3.3/Clipboard.cs	(revision 3528)
+++ trunk/sources/HeuristicLab.Core.Views/3.3/Clipboard.cs	(revision 3557)
@@ -231,8 +231,7 @@
       if (listView.SelectedItems.Count == 1) {
         T item = (T)listView.SelectedItems[0].Tag;
-        IView view = MainFormManager.CreateDefaultView(item);
+        IView view = MainFormManager.MainForm.ShowContent(item);
         if (view != null) {
           view.ReadOnly = this.ReadOnly;
-          view.Show();
         }
       }
Index: trunk/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.cs
===================================================================
--- trunk/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.cs	(revision 3528)
+++ trunk/sources/HeuristicLab.Core.Views/3.3/ItemArrayView.cs	(revision 3557)
@@ -229,9 +229,8 @@
         T item = itemsListView.SelectedItems[0].Tag as T;
         if (item != null) {
-          IContentView view = MainFormManager.CreateDefaultView(item);
+          IContentView view = MainFormManager.MainForm.ShowContent(item);
           if (view != null) {
             view.ReadOnly = ReadOnly;
             view.Locked = Locked;
-            view.Show();
           }
         }
Index: trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs
===================================================================
--- trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs	(revision 3528)
+++ trunk/sources/HeuristicLab.Core.Views/3.3/ItemCollectionView.cs	(revision 3557)
@@ -189,9 +189,8 @@
       if (itemsListView.SelectedItems.Count == 1) {
         T item = (T)itemsListView.SelectedItems[0].Tag;
-        IContentView view = MainFormManager.CreateDefaultView(item);
+        IContentView view = MainFormManager.MainForm.ShowContent(item);
         if (view != null) {
           view.ReadOnly = ReadOnly;
           view.Locked = Locked;
-          view.Show();
         }
       }
Index: trunk/sources/HeuristicLab.Core.Views/3.3/ItemListView.cs
===================================================================
--- trunk/sources/HeuristicLab.Core.Views/3.3/ItemListView.cs	(revision 3528)
+++ trunk/sources/HeuristicLab.Core.Views/3.3/ItemListView.cs	(revision 3557)
@@ -223,9 +223,8 @@
       if (itemsListView.SelectedItems.Count == 1) {
         T item = (T)itemsListView.SelectedItems[0].Tag;
-        IContentView view = MainFormManager.CreateDefaultView(item);
+        IContentView view = MainFormManager.MainForm.ShowContent(item);
         if (view != null) {
           view.ReadOnly = ReadOnly;
           view.Locked = Locked;
-          view.Show();
         }
       }
Index: trunk/sources/HeuristicLab.Core.Views/3.3/OperatorTreeView.cs
===================================================================
--- trunk/sources/HeuristicLab.Core.Views/3.3/OperatorTreeView.cs	(revision 3528)
+++ trunk/sources/HeuristicLab.Core.Views/3.3/OperatorTreeView.cs	(revision 3557)
@@ -355,10 +355,8 @@
         IOperator op = GetOperatorTag(graphTreeView.SelectedNode);
         if (op != null) {
-          IContentView view = MainFormManager.CreateDefaultView(op);
-          if (view != null) {
-            view.ReadOnly = this.ReadOnly;
-            view.Locked = this.Locked;
+          Type viewType = MainFormManager.GetDefaultViewType(op.GetType());
+          if (viewType != null) {
             viewToolStripMenuItem.Enabled = true;
-            viewToolStripMenuItem.Tag = view;
+            viewToolStripMenuItem.Tag = op;
           }
           breakpointToolStripMenuItem.Enabled = true;
@@ -414,6 +412,10 @@
     #region Context Menu Events
     private void viewToolStripMenuItem_Click(object sender, EventArgs e) {
-      IView view = ((ToolStripMenuItem)sender).Tag as IView;
-      if (view != null) view.Show();
+      IOperator op = ((ToolStripMenuItem)sender).Tag as IOperator;
+      IContentView view = MainFormManager.MainForm.ShowContent(op);
+      if (view != null) {
+        view.ReadOnly = this.ReadOnly;
+        view.Locked = this.Locked;
+      }
     }
     private void breakpointToolStripMenuItem_Click(object sender, EventArgs e) {